import { TokenSwap } from "../tokenswap.js";
import { pow10 } from "../common/utils.js";
import { BridgeConfigV3ContractInstance } from "../entities.js";
import { BigNumber } from "@ethersproject/bignumber";
export class BridgeConfig {
    instance;
    constructor() {
        this.instance = BridgeConfigV3ContractInstance();
    }
    calculateSwapFee(args) {
        const { chainIdFrom, chainIdTo, tokenFrom, amountFrom: baseAmountFrom } = args;
        const { bridgeConfigIntermediateToken } = TokenSwap.intermediateTokens(chainIdTo, tokenFrom);
        const intermediateTokenAddress = bridgeConfigIntermediateToken.address(chainIdTo).toLowerCase();
        const multiplier = pow10(18 - tokenFrom.decimals(chainIdFrom)), amountFrom = BigNumber.from(baseAmountFrom).mul(multiplier);
        const bridgeFee = this.instance["calculateSwapFee(string,uint256,uint256)"](intermediateTokenAddress, chainIdTo, amountFrom);
        return { bridgeFee, amountFrom };
    }
}
